package utals;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

public class Bankfik {
    private final Map<String, Bankszmla> szmlk;
    
    public Bankfik() {
        this.szmlk = new HashMap<>();
    }
    
    public Collection<Bankszmla> szmlk() {
        return szmlk.values();
    }
    
    public void jSzmla(Bankszmla szmla) {
        szmlk.put(szmla.szmlaszm(), szmla);
    }
    
    public void szmltTrl(Bankszmla szmla) {
        szmlk.remove(szmla.szmlaszm());
    }
    
    public void tvezet(String terhelendSzmlaSzma, String kedvezmnyezettSzmlaSzma, int sszeg)
            throws NincsFedezetKivtel, NemltezSzmlaKivtel, NegatvsszegKivtel {
        
        Bankszmla terhelendSzmla = szmlk.get(terhelendSzmlaSzma);
        if(terhelendSzmla == null) {
            throw new NemltezSzmlaKivtel(terhelendSzmlaSzma);
        }
        Bankszmla kedvezmnyezettSzmla = szmlk.get(kedvezmnyezettSzmlaSzma);
        if(kedvezmnyezettSzmla == null) {
            throw new NemltezSzmlaKivtel(kedvezmnyezettSzmlaSzma);
        }
        
        terhelendSzmla.terhel(sszeg);
        kedvezmnyezettSzmla.jvr(sszeg);
    }
    
    public void befizet(String kedvezmnyezettSzmlaSzma, int sszeg) throws NemltezSzmlaKivtel, NegatvsszegKivtel{
        Bankszmla kedvezmnyezettSzmla = szmlk.get(kedvezmnyezettSzmlaSzma);
        if(kedvezmnyezettSzmla == null) {
            throw new NemltezSzmlaKivtel(kedvezmnyezettSzmlaSzma);
        }
        kedvezmnyezettSzmla.jvr(sszeg);
    }
}
